/*
 *	spDraw_Win.h
 */

#ifndef __SPDRAW_WIN_H
#define __SPDRAW_WIN_H

#include <windows.h>
#include <sp/spGraphicsP.h>

#ifdef __cplusplus
extern "C" {
#endif

typedef struct _spPolygonArchPart {
    POINT *points;
} spPolygonArchPart;

extern void spDrawRectangleWin(HDC hdc, spGraphics graphics,
			       spGraphicsType type, HPEN null_pen, HBRUSH null_brush,
			       int x, int y, int width, int height);
extern void spDrawArcWin(HDC hdc, spGraphics graphics,
			 spGraphicsType type, HPEN null_pen, HBRUSH null_brush,
			 int x, int y, int width, int height, double angle1, double angle2);
extern void spDrawLineWin(HDC hdc, spGraphics graphics, int x1, int y1, int x2, int y2);
extern void spDrawPointWin(HDC hdc, spGraphics graphics, int x, int y);
extern void spDrawStringWin(HDC hdc, spGraphics graphics, int x, int y, const char *string);
extern spBool spGetStringExtentWin(HDC hdc, spGraphics graphics, const char *string,
				   int *x, int *y, int *width, int *height, int *next_x);
extern spBool spDrawPolygonWin(HDC hdc, spGraphics graphics,
			       spGraphicsType type, HPEN null_pen, HBRUSH null_brush, spPolygon polygon);
    
extern unsigned long spGetDrawingCapsWin(void);

extern void spUpdateCompatibleBitmapWin(spComponent component, int width, int height);
    
#ifdef __cplusplus
}  /* Close scope of 'extern "C"' declaration */
#endif

#endif /* __SPDRAW_WIN_H */
