/*
 *	spComboBox_Gtk.c
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include <sp/spDefs.h>
#include <sp/spMemory.h>

#include <sp/spListP.h>
#include <sp/spComboBoxP.h>

GtkWidget *spGetComboBoxEntryGtk(spComponent component)
{
    GtkWidget *widget;
    
#if GTK_CHECK_VERSION(3,0,0)
    widget = gtk_bin_get_child(GTK_BIN(SpPrimitiveArch(component).widget));
#else
    widget = (GtkWidget *)GTK_COMBO(SpPrimitiveArch(component).widget)->entry;
#endif

    return widget;
}

long spGetComboBoxTextLengthGtk(spComponent component)
{
#if GTK_CHECK_VERSION(3,0,0)
    return gtk_entry_get_text_length(GTK_ENTRY(spGetComboBoxEntryGtk(component)));
#else
    return GTK_ENTRY(spGetComboBoxEntryGtk(component))->text_length;
#endif
}

void spComboBoxCreateArch(spComponent component)
{
#if GTK_CHECK_VERSION(3,0,0)
    SpComboBoxArch(component).model = GTK_TREE_MODEL(gtk_list_store_new(1, G_TYPE_STRING));
    if (SpComboBoxPart(component).select_only == SP_TRUE) {
	GtkCellRenderer *renderer;
	
	SpPrimitiveArch(component).widget = gtk_combo_box_new_with_model(SpComboBoxArch(component).model);

	renderer = gtk_cell_renderer_text_new();
	gtk_cell_layout_pack_start(GTK_CELL_LAYOUT(SpPrimitiveArch(component).widget), renderer, TRUE);
	gtk_cell_layout_set_attributes(GTK_CELL_LAYOUT(SpPrimitiveArch(component).widget), renderer,
				       "text", 0,
				       NULL);
    } else {
	SpPrimitiveArch(component).widget = gtk_combo_box_new_with_model_and_entry(SpComboBoxArch(component).model);
	gtk_combo_box_set_entry_text_column(GTK_COMBO_BOX(SpPrimitiveArch(component).widget), 0);

	gtk_entry_set_width_chars(GTK_ENTRY(spGetComboBoxEntryGtk(component)), 2);
    }
#else
    SpPrimitiveArch(component).widget = gtk_combo_new();
#endif
    
#if GTK_CHECK_VERSION(3,0,0)
    if (SpComboBoxPart(component).select_only == SP_FALSE) {
	gtk_editable_set_editable(GTK_EDITABLE(spGetComboBoxEntryGtk(component)),
				  (SpTextPart(component).editable == SP_TRUE ? TRUE : FALSE));
    }
#else
    gtk_entry_set_editable(GTK_ENTRY(spGetComboBoxEntryGtk(component)),
			   (SpTextPart(component).editable == SP_TRUE ? TRUE : FALSE));
#endif
    
    spPrimitiveContainerAddGtk(component);
    
    return;
}

void spComboBoxSetParamsArch(spComponent component)
{
    if (SpTextPart(SpOldObject(component)).editable != SpTextPart(component).editable) {
#if GTK_CHECK_VERSION(3,0,0)
	if (SpComboBoxPart(component).select_only == SP_FALSE) {
	    gtk_editable_set_editable(GTK_EDITABLE(spGetComboBoxEntryGtk(component)),
				      (SpTextPart(component).editable == SP_TRUE ? TRUE : FALSE));
	}
#else
	gtk_entry_set_editable(GTK_ENTRY(spGetComboBoxEntryGtk(component)),
			       (SpTextPart(component).editable == SP_TRUE ? TRUE : FALSE));
#endif
    }
    
    return;
}
