/*
 *	spContainer_Gtk.c
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include <sp/spDefs.h>
#include <sp/spBase.h>
#include <sp/spMemory.h>

#include <sp/spTabBox.h>
#include <sp/spDialog.h>

#include <sp/spFrameP.h>
#include <sp/spContainerP.h>

#define SP_DEFAULT_CONTAINER_MARGIN_BOTTOM 17

void spContainerCreateArch(spComponent component)
{
    if (SpContainerPart(component).border_on == SP_TRUE) {
	SpComponentPart(component).border_width = 2;
	
	if (SpContainerPart(component).title_on == SP_TRUE) {
	    SpComponentPart(component).margin_bottom = SP_DEFAULT_CONTAINER_MARGIN_BOTTOM;
	    SpPrimitiveArch(component).top_widget =
		gtk_frame_new(spGetTitle(component));
	    gtk_frame_set_shadow_type(GTK_FRAME(SpPrimitiveArch(component).top_widget),
				      GTK_SHADOW_ETCHED_IN);
	} else {
	    SpPrimitiveArch(component).top_widget = gtk_frame_new(NULL);
	    gtk_frame_set_shadow_type(GTK_FRAME(SpPrimitiveArch(component).top_widget),
				      GTK_SHADOW_IN);
	}
#if GTK_CHECK_VERSION(3,0,0)
	gtk_container_set_border_width(GTK_CONTAINER(SpPrimitiveArch(component).top_widget),
				       SpComponentPart(component).border_width);
#else
	gtk_container_border_width(GTK_CONTAINER(SpPrimitiveArch(component).top_widget),
				   SpComponentPart(component).border_width);
#endif
	
#if !GTK_CHECK_VERSION(3,0,0)
	if (spIsSubClass(SpGetParent(component), SpFileDialog) == SP_TRUE) {
	    gtk_box_pack_end(GTK_BOX(GTK_FILE_SELECTION(SpParentPrimitiveArch(component).widget)->main_vbox),
			     SpPrimitiveArch(component).top_widget, TRUE, TRUE, 5);
	} else
#endif
	if (spIsSubClass(SpGetParent(component), SpTabBox) == SP_FALSE) {
	    spContainerAddGtk(component, SpPrimitiveArch(component).top_widget);
	}
	if (SpComponentPart(component).visible_flag == SP_TRUE) {
	    gtk_widget_show(SpPrimitiveArch(component).top_widget);
	}
    }

#if GTK_CHECK_VERSION(3,0,0) && defined(SP_USE_GTK_GRID)
    SpPrimitiveArch(component).widget =	gtk_grid_new();
    gtk_grid_set_row_spacing(GTK_GRID(SpPrimitiveArch(component).widget),
			     /*SpComponentPart(component).spacing*/0);
    gtk_grid_set_column_spacing(GTK_GRID(SpPrimitiveArch(component).widget),
				/*SpComponentPart(component).spacing*/0);
#else
    SpPrimitiveArch(component).widget =	gtk_fixed_new();
#if GTK_CHECK_VERSION(3,0,0)
    gtk_widget_set_has_window(SpPrimitiveArch(component).widget, TRUE);
#elif GTK_CHECK_VERSION(2,0,0)
    gtk_fixed_set_has_window(GTK_FIXED(SpPrimitiveArch(component).widget), TRUE);
#endif
#endif	/* !(GTK_CHECK_VERSION(3,0,0) && defined(SP_USE_GTK_GRID)) */
    
    spSetStyleGtk(component, SpPrimitiveArch(component).widget);

    if (SpPrimitiveArch(component).top_widget != NULL) {
	gtk_container_add(GTK_CONTAINER(SpPrimitiveArch(component).top_widget),
			  SpPrimitiveArch(component).widget);
    } else {
#if !GTK_CHECK_VERSION(3,0,0)
	if (spIsSubClass(SpGetParent(component), SpFileDialog) == SP_TRUE) {
	    spDebug(30, "spContainerCreateArch", "parent is SpFileDialog\n");
	    gtk_box_pack_start(GTK_BOX(GTK_FILE_SELECTION(SpParentPrimitiveArch(component).widget)->main_vbox),
			     SpPrimitiveArch(component).widget, TRUE, TRUE, 0);
	} else
#endif
	if (spIsSubClass(SpGetParent(component), SpTabBox) == SP_FALSE) {
	    spContainerAddGtk(component, SpPrimitiveArch(component).widget);
	}
    }
    
    if (spIsVisible(component) == SP_TRUE
	||spIsSubClass(SpGetParent(component), SpTabBox) == SP_TRUE) {
	gtk_widget_show(SpPrimitiveArch(component).widget);
    }
    
    return;
}

void spContainerSetParamsArch(spComponent component)
{
    return;
}
