/*
 *	spTabBox_Gtk.c
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include <sp/spDefs.h>
#include <sp/spBase.h>
#include <sp/spMemory.h>

#include <sp/spListP.h>
#include <sp/spTabBoxP.h>

extern spTopLevel sp_toplevel;

void spTabBoxPartInitArch(spComponent component)
{
    return;
}

void spTabBoxPartFreeArch(spComponent component)
{
    return;
}

static void switchTabItemCB(GtkNotebook *widget,
#if GTK_CHECK_VERSION(3,0,0)
			    GtkWidget *page,
#else
			    GtkNotebookPage *page,
#endif
			    guint page_num)
{
    int index;
    spComponent component;
    spComponent child;

#if GTK_CHECK_VERSION(3,0,0)
    component = (spComponent)g_object_get_data(G_OBJECT(widget), "spComponent");
#else
    component = (spComponent)gtk_object_get_data(GTK_OBJECT(widget), "spComponent");
#endif
    
    if (
#if GTK_CHECK_VERSION(3,0,0)
	gtk_widget_get_mapped(GTK_WIDGET(widget))
#else
	GTK_WIDGET_MAPPED(widget)
#endif
	&& component != NULL) {
	index = page_num;

	spDebug(10, "switchTabItemCB", "index = %d\n", index);
	child = SpGetChild(component);
	
	while (child != NULL) {
	    if (SpPrimitivePart(child).index == index) {
		SpComponentPart(child).visible_flag = SP_TRUE;
	    } else {
		SpComponentPart(child).visible_flag = SP_FALSE;
	    }

	    child = SpGetNextComponent(child);
	}
	
	spAdjustComponentSize(component);
    }
    
    return;
}

void spTabBoxCreateArch(spComponent component)
{
    SpComponentPart(component).border_width = 3;
    
    SpPrimitiveArch(component).widget =	gtk_notebook_new();
    
    gtk_notebook_set_tab_pos(GTK_NOTEBOOK(SpPrimitiveArch(component).widget), GTK_POS_TOP);
#if GTK_CHECK_VERSION(3,0,0)
    g_object_set_data(G_OBJECT(SpPrimitiveArch(component).widget),
		      "spComponent", (gpointer)component);
#else
    gtk_object_set_data(GTK_OBJECT(SpPrimitiveArch(component).widget),
			"spComponent", (gpointer)component);
#endif

    spPrimitiveContainerAddGtk(component);
    
#if GTK_CHECK_VERSION(3,0,0)
    g_signal_connect(SpPrimitiveArch(component).widget,
		     "switch_page", G_CALLBACK(switchTabItemCB),
		     NULL);
#else
    gtk_signal_connect(GTK_OBJECT(SpPrimitiveArch(component).widget),
		       "switch_page", GTK_SIGNAL_FUNC(switchTabItemCB),
		       NULL);
#endif
    
    return;
}

void spTabBoxSetParamsArch(spComponent component)
{
    return;
}

void spTabBoxDestroyArch(spComponent component)
{
    return;
}

int spMapTabItemArch(spComponent component, int index)
{
    return spMapTabItemDefault(component, index);
}

int spGetSelectedTabIndexArch(spComponent component)
{
#if GTK_CHECK_VERSION(3,0,0)
    return gtk_notebook_get_current_page(GTK_NOTEBOOK(SpPrimitiveArch(component).widget));
#else
    return gtk_notebook_current_page(GTK_NOTEBOOK(SpPrimitiveArch(component).widget));
#endif
}

void spAddTabItemArch(spComponent component, int index)
{
    SpComponentPart(component).top_offset += SP_DEFAULT_TAB_HEIGHT;

    SpPrimitiveArch(component).sub_widget = gtk_label_new(spGetTitle(component));
    gtk_notebook_append_page(GTK_NOTEBOOK(SpParentPrimitiveArch(component).widget),
			     SpPrimitiveArch(component).widget,
			     SpPrimitiveArch(component).sub_widget);
    
    return;
}
