/*
 *	spToolBar_Xm.c
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <X11/Xlib.h>
#include <X11/Intrinsic.h>
#include <X11/Shell.h>
#include <X11/xpm.h>
#include <Xm/Xm.h>
#include <Xm/RowColumn.h>
#include <Xm/DrawingA.h>
#include <Xm/Form.h>
#include <Xm/Frame.h>
#include <Xm/Label.h>

#include <sp/spDefs.h>
#include <sp/spBase.h>
#include <sp/spMemory.h>

#include <sp/spGraphicsP.h>
#include <sp/spDrawP.h>
#include <sp/spToolBarP.h>

void spToolBarPartInitArch(spComponent component)
{
    return;
}

void spToolBarPartFreeArch(spComponent component)
{
    return;
}

void spToolBarCreateArch(spComponent component)
{
    int narg = 0;
    Arg args[10];

    XtSetArg(args[narg], XmNmarginWidth, 0); narg++;
    XtSetArg(args[narg], XmNmarginHeight, 0); narg++;
    XtSetArg(args[narg], XmNresizePolicy, XmRESIZE_NONE); narg++;
    XtSetArg(args[narg], XmNtraversalOn, False); narg++;
    SpPrimitiveArch(component).widget =
	XtCreateWidget((!strnone(SpGetName(component)) ? SpGetName(component) : ""),
		       xmDrawingAreaWidgetClass, 
		       SpParentPrimitiveArch(component).widget,
		       args, narg);
    
    SpPrimitiveArch(component).display = XtDisplay(SpPrimitiveArch(component).widget);
    SpPrimitiveArch(component).screen = XtScreen(SpPrimitiveArch(component).widget);

    SpPrimitiveArch(component).pixmap = spCreatePixmapFromDataOrFileXm(SpParentPrimitiveArch(component).widget,
								       SpToolBarPart(component).bitmap_data,
								       SpGetName(component), NULL, NULL);
    
    if (spIsVisible(component) == SP_TRUE) {
	XtManageChild(SpPrimitiveArch(component).widget);
    }
    
    spDebug(30, "spToolBarCreateArch", "create done\n");

    return;
}

void spToolBarSetParamsArch(spComponent component)
{
    return;
}
    
void spToolBarDestroyArch(spComponent component)
{
    return;
}
